CfnIndex L1 construct
Creates an Amazon Kendra index.
Once the index is active you can add documents to your index using the BatchPutDocument operation or using one of the supported data sources.
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_kendra as kendra } from 'aws-cdk-lib';
const cfnIndex = new kendra.CfnIndex(this, 'MyCfnIndex', {
edition: 'edition',
name: 'name',
roleArn: 'roleArn',
// the properties below are optional
capacityUnits: {
queryCapacityUnits: 123,
storageCapacityUnits: 123,
},
description: 'description',
documentMetadataConfigurations: [{
name: 'name',
type: 'type',
// the properties below are optional
relevance: {
duration: 'duration',
freshness: false,
importance: 123,
rankOrder: 'rankOrder',
valueImportanceItems: [{
key: 'key',
value: 123,
}],
},
search: {
displayable: false,
facetable: false,
searchable: false,
sortable: false,
},
}],
serverSideEncryptionConfiguration: {
kmsKeyId: 'kmsKeyId',
},
tags: [{
key: 'key',
value: 'value',
}],
userContextPolicy: 'userContextPolicy',
userTokenConfigurations: [{
jsonTokenTypeConfiguration: {
groupAttributeField: 'groupAttributeField',
userNameAttributeField: 'userNameAttributeField',
},
jwtTokenTypeConfiguration: {
keyLocation: 'keyLocation',
// the properties below are optional
claimRegex: 'claimRegex',
groupAttributeField: 'groupAttributeField',
issuer: 'issuer',
secretManagerArn: 'secretManagerArn',
url: 'url',
userNameAttributeField: 'userNameAttributeField',
},
}],
});
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_kendra as kendra
cfn_index = kendra.CfnIndex(self, "MyCfnIndex",
edition="edition",
name="name",
role_arn="roleArn",
# the properties below are optional
capacity_units=kendra.CfnIndex.CapacityUnitsConfigurationProperty(
query_capacity_units=123,
storage_capacity_units=123
),
description="description",
document_metadata_configurations=[kendra.CfnIndex.DocumentMetadataConfigurationProperty(
name="name",
type="type",
# the properties below are optional
relevance=kendra.CfnIndex.RelevanceProperty(
duration="duration",
freshness=False,
importance=123,
rank_order="rankOrder",
value_importance_items=[kendra.CfnIndex.ValueImportanceItemProperty(
key="key",
value=123
)]
),
search=kendra.CfnIndex.SearchProperty(
displayable=False,
facetable=False,
searchable=False,
sortable=False
)
)],
server_side_encryption_configuration=kendra.CfnIndex.ServerSideEncryptionConfigurationProperty(
kms_key_id="kmsKeyId"
),
tags=[CfnTag(
key="key",
value="value"
)],
user_context_policy="userContextPolicy",
user_token_configurations=[kendra.CfnIndex.UserTokenConfigurationProperty(
json_token_type_configuration=kendra.CfnIndex.JsonTokenTypeConfigurationProperty(
group_attribute_field="groupAttributeField",
user_name_attribute_field="userNameAttributeField"
),
jwt_token_type_configuration=kendra.CfnIndex.JwtTokenTypeConfigurationProperty(
key_location="keyLocation",
# the properties below are optional
claim_regex="claimRegex",
group_attribute_field="groupAttributeField",
issuer="issuer",
secret_manager_arn="secretManagerArn",
url="url",
user_name_attribute_field="userNameAttributeField"
)
)]
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.kendra.*;
CfnIndex cfnIndex = CfnIndex.Builder.create(this, "MyCfnIndex")
.edition("edition")
.name("name")
.roleArn("roleArn")
// the properties below are optional
.capacityUnits(CapacityUnitsConfigurationProperty.builder()
.queryCapacityUnits(123)
.storageCapacityUnits(123)
.build())
.description("description")
.documentMetadataConfigurations(List.of(DocumentMetadataConfigurationProperty.builder()
.name("name")
.type("type")
// the properties below are optional
.relevance(RelevanceProperty.builder()
.duration("duration")
.freshness(false)
.importance(123)
.rankOrder("rankOrder")
.valueImportanceItems(List.of(ValueImportanceItemProperty.builder()
.key("key")
.value(123)
.build()))
.build())
.search(SearchProperty.builder()
.displayable(false)
.facetable(false)
.searchable(false)
.sortable(false)
.build())
.build()))
.serverSideEncryptionConfiguration(ServerSideEncryptionConfigurationProperty.builder()
.kmsKeyId("kmsKeyId")
.build())
.tags(List.of(CfnTag.builder()
.key("key")
.value("value")
.build()))
.userContextPolicy("userContextPolicy")
.userTokenConfigurations(List.of(UserTokenConfigurationProperty.builder()
.jsonTokenTypeConfiguration(JsonTokenTypeConfigurationProperty.builder()
.groupAttributeField("groupAttributeField")
.userNameAttributeField("userNameAttributeField")
.build())
.jwtTokenTypeConfiguration(JwtTokenTypeConfigurationProperty.builder()
.keyLocation("keyLocation")
// the properties below are optional
.claimRegex("claimRegex")
.groupAttributeField("groupAttributeField")
.issuer("issuer")
.secretManagerArn("secretManagerArn")
.url("url")
.userNameAttributeField("userNameAttributeField")
.build())
.build()))
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.Kendra;
var cfnIndex = new CfnIndex(this, "MyCfnIndex", new CfnIndexProps {
Edition = "edition",
Name = "name",
RoleArn = "roleArn",
// the properties below are optional
CapacityUnits = new CapacityUnitsConfigurationProperty {
QueryCapacityUnits = 123,
StorageCapacityUnits = 123
},
Description = "description",
DocumentMetadataConfigurations = new [] { new DocumentMetadataConfigurationProperty {
Name = "name",
Type = "type",
// the properties below are optional
Relevance = new RelevanceProperty {
Duration = "duration",
Freshness = false,
Importance = 123,
RankOrder = "rankOrder",
ValueImportanceItems = new [] { new ValueImportanceItemProperty {
Key = "key",
Value = 123
} }
},
Search = new SearchProperty {
Displayable = false,
Facetable = false,
Searchable = false,
Sortable = false
}
} },
ServerSideEncryptionConfiguration = new ServerSideEncryptionConfigurationProperty {
KmsKeyId = "kmsKeyId"
},
Tags = new [] { new CfnTag {
Key = "key",
Value = "value"
} },
UserContextPolicy = "userContextPolicy",
UserTokenConfigurations = new [] { new UserTokenConfigurationProperty {
JsonTokenTypeConfiguration = new JsonTokenTypeConfigurationProperty {
GroupAttributeField = "groupAttributeField",
UserNameAttributeField = "userNameAttributeField"
},
JwtTokenTypeConfiguration = new JwtTokenTypeConfigurationProperty {
KeyLocation = "keyLocation",
// the properties below are optional
ClaimRegex = "claimRegex",
GroupAttributeField = "groupAttributeField",
Issuer = "issuer",
SecretManagerArn = "secretManagerArn",
Url = "url",
UserNameAttributeField = "userNameAttributeField"
}
} }
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
cfnIndex := awscdk.Aws_kendra.NewCfnIndex(this, jsii.String("MyCfnIndex"), &CfnIndexProps{
Edition: jsii.String("edition"),
Name: jsii.String("name"),
RoleArn: jsii.String("roleArn"),
// the properties below are optional
CapacityUnits: &CapacityUnitsConfigurationProperty{
QueryCapacityUnits: jsii.Number(123),
StorageCapacityUnits: jsii.Number(123),
},
Description: jsii.String("description"),
DocumentMetadataConfigurations: []interface{}{
&DocumentMetadataConfigurationProperty{
Name: jsii.String("name"),
Type: jsii.String("type"),
// the properties below are optional
Relevance: &RelevanceProperty{
Duration: jsii.String("duration"),
Freshness: jsii.Boolean(false),
Importance: jsii.Number(123),
RankOrder: jsii.String("rankOrder"),
ValueImportanceItems: []interface{}{
&ValueImportanceItemProperty{
Key: jsii.String("key"),
Value: jsii.Number(123),
},
},
},
Search: &SearchProperty{
Displayable: jsii.Boolean(false),
Facetable: jsii.Boolean(false),
Searchable: jsii.Boolean(false),
Sortable: jsii.Boolean(false),
},
},
},
ServerSideEncryptionConfiguration: &ServerSideEncryptionConfigurationProperty{
KmsKeyId: jsii.String("kmsKeyId"),
},
Tags: []CfnTag{
&CfnTag{
Key: jsii.String("key"),
Value: jsii.String("value"),
},
},
UserContextPolicy: jsii.String("userContextPolicy"),
UserTokenConfigurations: []interface{}{
&UserTokenConfigurationProperty{
JsonTokenTypeConfiguration: &JsonTokenTypeConfigurationProperty{
GroupAttributeField: jsii.String("groupAttributeField"),
UserNameAttributeField: jsii.String("userNameAttributeField"),
},
JwtTokenTypeConfiguration: &JwtTokenTypeConfigurationProperty{
KeyLocation: jsii.String("keyLocation"),
// the properties below are optional
ClaimRegex: jsii.String("claimRegex"),
GroupAttributeField: jsii.String("groupAttributeField"),
Issuer: jsii.String("issuer"),
SecretManagerArn: jsii.String("secretManagerArn"),
Url: jsii.String("url"),
UserNameAttributeField: jsii.String("userNameAttributeField"),
},
},
},
})
Initializer
new CfnIndex(scope: Construct, id: string, props: CfnIndexProps)
CfnIndex(scope: Construct, id: str, props: CfnIndexProps)
new CfnIndex(Construct scope, String id, CfnIndexProps props)
new CfnIndex(Construct scope, string id, CfnIndexProps props)
NewCfnIndex(Scope Construct, Id *string, Props CfnIndexProps)
Construct Props
capacityUnitsoptionalIResolvable | CfnIndex.CapacityUnitsConfigurationPropertycapacity_unitsoptionaltyping.Union[IResolvable, CapacityUnitsConfigurationProperty]capacityUnitsoptionalIResolvableCapacityUnitsoptionalIResolvableCapacityUnitsoptionalinterface{}#You can add and remove capacity units to fit your usage requirements.
descriptionoptionalstringdescriptionoptionalstrdescriptionoptionalStringDescriptionoptionalstringDescriptionoptional*string#documentMetadataConfigurationsoptionalIResolvable | IResolvable | CfnIndex.DocumentMetadataConfigurationProperty[]document_metadata_configurationsoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, DocumentMetadataConfigurationProperty]]]documentMetadataConfigurationsoptionalIResolvableDocumentMetadataConfigurationsoptionalIResolvableDocumentMetadataConfigurationsoptionalinterface{}#notes
You can add either a custom or a built-in field. You can add and remove built-in fields at any time. When a built-in field is removed it's configuration reverts to the default for the field. Custom fields can't be removed from an index after they are added.
roleArnstring | IRoleRefrole_arntyping.Union[str, IRoleRef]roleArnStringRoleArnstringRoleArninterface{}required#This is also the role used when you use the BatchPutDocument operation to index documents from an Amazon S3 bucket.
serverSideEncryptionConfigurationoptionalIResolvable | CfnIndex.ServerSideEncryptionConfigurationPropertyserver_side_encryption_configurationoptionaltyping.Union[IResolvable, ServerSideEncryptionConfigurationProperty]serverSideEncryptionConfigurationoptionalIResolvableServerSideEncryptionConfigurationoptionalIResolvableServerSideEncryptionConfigurationoptionalinterface{}#Amazon Kendra doesn't support asymmetric CMKs.
tagsoptionalCfnTag[]tagsoptionaltyping.List[CfnTag]tagsoptionalList<CfnTag>TagsoptionalCfnTag[]Tagsoptional*[]CfnTag#For more information, see Tag .
userContextPolicyoptionalstringuser_context_policyoptionalstruserContextPolicyoptionalStringUserContextPolicyoptionalstringUserContextPolicyoptional*string#notes
ATTRIBUTE_FILTER
- All indexed content is searchable and displayable for all users. If you want to filter search results on user context, you can use the attribute filters of
_user_idand_group_idsor you can provide user and group information inUserContext.
USER_TOKEN
- Enables token-based user access control to filter search results on user context. All documents with no access control and all documents accessible to the user will be searchable and displayable.
userTokenConfigurationsoptionalIResolvable | IResolvable | CfnIndex.UserTokenConfigurationProperty[]user_token_configurationsoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, UserTokenConfigurationProperty]]]userTokenConfigurationsoptionalIResolvableUserTokenConfigurationsoptionalIResolvableUserTokenConfigurationsoptionalinterface{}#Properties
For example: arn:aws:kendra:us-west-2:111122223333:index/0123456789abcdef .
For example: f4aeaa10-8056-4b2c-a343-522ca0f41234 .
capacityUnitsmay be undefinedIResolvable | CfnIndex.CapacityUnitsConfigurationPropertycapacity_unitsmay be undefinedtyping.Union[IResolvable, CapacityUnitsConfigurationProperty]capacityUnitsmay be undefinedIResolvableCapacityUnitsmay be undefinedIResolvableCapacityUnitsmay be undefinedinterface{}#CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptions#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*string#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*string#descriptionmay be undefinedstringdescriptionmay be undefinedstrdescriptionmay be undefinedStringDescriptionmay be undefinedstringDescriptionmay be undefined*string#documentMetadataConfigurationsmay be undefinedIResolvable | IResolvable | CfnIndex.DocumentMetadataConfigurationProperty[]document_metadata_configurationsmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, DocumentMetadataConfigurationProperty]]]documentMetadataConfigurationsmay be undefinedIResolvableDocumentMetadataConfigurationsmay be undefinedIResolvableDocumentMetadataConfigurationsmay be undefinedinterface{}#indexRefIndexReferenceindex_refIndexReferenceindexRefIndexReferenceIndexRefIndexReferenceIndexRefIndexReference#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
serverSideEncryptionConfigurationmay be undefinedIResolvable | CfnIndex.ServerSideEncryptionConfigurationPropertyserver_side_encryption_configurationmay be undefinedtyping.Union[IResolvable, ServerSideEncryptionConfigurationProperty]serverSideEncryptionConfigurationmay be undefinedIResolvableServerSideEncryptionConfigurationmay be undefinedIResolvableServerSideEncryptionConfigurationmay be undefinedinterface{}#CfnElements must be defined within a stack scope (directly or indirectly).
tagsRawmay be undefinedCfnTag[]tags_rawmay be undefinedtyping.List[CfnTag]tagsRawmay be undefinedList<CfnTag>TagsRawmay be undefinedCfnTag[]TagsRawmay be undefined*[]CfnTag#userContextPolicymay be undefinedstringuser_context_policymay be undefinedstruserContextPolicymay be undefinedStringUserContextPolicymay be undefinedstringUserContextPolicymay be undefined*string#userTokenConfigurationsmay be undefinedIResolvable | IResolvable | CfnIndex.UserTokenConfigurationProperty[]user_token_configurationsmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, UserTokenConfigurationProperty]]]userTokenConfigurationsmay be undefinedIResolvableUserTokenConfigurationsmay be undefinedIResolvableUserTokenConfigurationsmay be undefinedinterface{}#Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#fromIndexArn(scope: Construct, id: string, arn: string): IIndexRef@staticmethod def from_index_arn(scope: Construct, id: str, arn: str) -> IIndexRefpublic static IIndexRef fromIndexArn(Construct scope, String id, String arn)public static IIndexRef FromIndexArn(Construct scope, string id, string arn)func FromIndexArn(Scope Construct, Id *string, Arn *string) IIndexRefstatic#fromIndexId(scope: Construct, id: string, indexId: string): IIndexRef@staticmethod def from_index_id(scope: Construct, id: str, index_id: str) -> IIndexRefpublic static IIndexRef fromIndexId(Construct scope, String id, String indexId)public static IIndexRef FromIndexId(Construct scope, string id, string indexId)func FromIndexId(Scope Construct, Id *string, IndexId *string) IIndexRefstatic#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnIndex(x: any): boolean@staticmethod def is_cfn_index(x: Any) -> boolpublic static Boolean isCfnIndex(Object x)public static bool IsCfnIndex(object x)func IsCfnIndex(X interface{}) *boolstatic#isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.